FLANG

Public Types | Public Member Functions | Public Attributes | List of all members
Fortran::lower::pft::ModuleLikeUnit Struct Reference

Module-like units contain a list of function-like units. More...

`#include <flang/Lower/PFTBuilder.h>`

Inheritance diagram for Fortran::lower::pft::ModuleLikeUnit:

## Public Types
using | ModuleStatement = ReferenceVariant< parser::Statement< parser::ModuleStmt >, parser::Statement< parser::EndModuleStmt >, parser::Statement< parser::SubmoduleStmt >, parser::Statement< parser::EndSubmoduleStmt > >
Public Types inherited from Fortran::lower::pft::ReferenceVariantBase< isConst, A >
template<typename B >
using | BaseType = std::conditional_t< isConst, const B, B >
template<typename B >
using | Ref = common::Reference< BaseType< B > >

## Public Member Functions
| ModuleLikeUnit (const parser::Module &m, const ParentVariant &parentVariant)
| ModuleLikeUnit (const parser::Submodule &m, const ParentVariant &parentVariant)
| ModuleLikeUnit (ModuleLikeUnit &&)=default
| ModuleLikeUnit (const ModuleLikeUnit &)=delete
Public Member Functions inherited from Fortran::lower::pft::ProgramUnit
template<typename A >
| ProgramUnit (const A &p, const ParentVariant &parentVariant)
| ProgramUnit (ProgramUnit &&)=default
| ProgramUnit (const ProgramUnit &)=delete
Public Member Functions inherited from Fortran::lower::pft::ReferenceVariantBase< isConst, A >
template<typename B >
| ReferenceVariantBase (B &b)
template<typename B >
constexpr BaseType< B > & | get () const
template<typename B >
constexpr BaseType< B > * | getIf () const
template<typename B >
constexpr bool | isA () const
template<typename VISITOR >
constexpr auto | visit (VISITOR &&visitor) const

## Public Attributes
ModuleStatement | beginStmt
ModuleStatement | endStmt
std::list< FunctionLikeUnit > | nestedFunctions
Public Attributes inherited from Fortran::lower::pft::ProgramUnit
ParentVariant | parentVariant

## Detailed Description

Module-like units contain a list of function-like units.

The documentation for this struct was generated from the following files:

- include/flang/Lower/PFTBuilder.h
- lib/Lower/PFTBuilder.cpp